<?php
/*******************************************************************************************
*                                                                                          *
*  CAO-Faktura für Windows Version 1.4 (http://www.cao-faktura.de)                         *
*  Copyright (C) 2003 Jan Pokrandt / Jan@JP-SOFT.de                                        *
*                                                                                          *
*  This program is free software; you can redistribute it and/or                           *
*  modify it under the terms of the GNU General Public License                             *
*  as published by the Free Software Foundation; either version 2                          *
*  of the License, or any later version.                                                   *
*                                                                                          *
*  This program is distributed in the hope that it will be useful,                         *
*  but WITHOUT ANY WARRANTY; without even the implied warranty of                          *
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                           *
*  GNU General Public License for more details.                                            *
*                                                                                          *
*  You should have received a copy of the GNU General Public License                       *
*  along with this program; if not, write to the Free Software                             *
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
*                                                                                          *
*  ******* This Scripts comes with ABSOLUTELY NO WARRANTY ***************                  *
*                                                                                          *
********************************************************************************************
*                                                                                          *
* Eine Entfernung oder Veraenderung dieses Dateiheaders ist nicht zulaessig !!!            *
* Wenn Sie diese Datei veraendern dann fuegen Sie ihre eigenen Copyrightmeldungen          *
* am Ende diese Headers an                                                                 *
*                                                                                          *
********************************************************************************************
*                                                                                          *
*  Programm     : CAO-Faktura                                                              *
*  Modul        : cao_xtc.php                                                              *
*  Stand        : 25.04.2008                                                               *
*  Version      : 1.55                                                                     *
*  Beschreibung : Script zum Datenaustausch CAO-Faktura <--> xtCommerce-Shop               *
*                                                                                          *
*  based on:                                                                               *
* (c) 2000 - 2001 The Exchange Project                                                     *
* (c) 2001 - 2003 osCommerce, Open Source E-Commerce Solutions                             *
* (c) 2001 - 2003 TheMedia, Dipl.-Ing Thomas Plänkers                                      *
* (c) 2003 JP-Soft, Jan Pokrandt                                                           *
* (c) 2003 IN-Solution, Henri Schmidhuber                                                  *
* (c) 2003 www.websl.de, Karl Langmann                                                     *
* (c) 2003 RV-Design Raphael Vullriede                                                     *
* (c) 2004 XT-Commerce                                                                     *
*                                                                                          *
* Released under the GNU General Public License                                            *
*                                                                                          *
*  History :                                                                               *
*                                                                                          *
*  - 25.06.2003 JP Version 0.1 released                                                    *
*  - 26.06.2003 HS beim Orderexport orderstatus und comment hinzugefuegt                   *
*  - 29.06.2003 JP order_update entfernt und in die Datei cao_update.php verschoben        *
*  - 17.07.2003 tep_array_merge durch array_merge ersetzt                                  *
*  - 18.07.2003 Code fuer Image_Upload hinzugefuegt                                        *
*  - 20.07.2003 HS Shipping und Paymentklassen aufgenommen                                 *
*  - 02.08.2003 KL MANUFACTURERS_DESCRIPTION  language_id geändert in languages_id         *
*  - 09.08.2003 JP fuer das Modul Banktransfer werden jetzt die daten bei der Bestll-      *
*                  uebermittlung mit ausgegeben                                            *
*  - 10.08.2003 JP Geburtsdatum wird jetzt in den Bestellungen mit uebergeben              *
*  - 18.08.2003 JP Bug bei Products/URL beseitigt                                          *
*  - 18.08.2003 HS Bankdaten werden nur bei Banktransfer ausgelesen                        *
*  - 23.08.2003 Code fuer Hersteller-Update hinzugefuegt                                   *
*  - 25.10.2003 RV Kunden-Export hinzugefügt                                               *
*  - 24.11.2003 HS Fix Kunden-Export - Newsletterexport hinzugefügt                        *
*  - 01.12.2003 RV Code für 3 Produktbilder-Erweiterung hinzugefügt.                       *
*  - 31.01.2004 JP Resourcenverbrauch minimiert                                            *
*                  tep_set_time_limit ist jetzt per DEFINE zu- und abschaltbar             *
*  - 06.06.2004 JP per DEFINE kann jetzt die Option "3 Produktbilder" geschaltet werden    *
*  - 09.10.2004 RV automatisch Erkennung von 3 Bilder Contrib laut readme                  *
*  - 09.10.2004 RV vereinheitlicher Adress-Export bei Bestellungen und Kunden              *
*  - 09.10.2004 RV Kunden Vor- und Nachname bei Bestellungen getrennt exportieren          *
*  - 09.10.2004 RV SQL-Cleanup                                                             *
*  - 09.10.2004 RV CODE-Cleanup                                                            *
*  - 14.10.2004 RV Länder bei Bestellungen als ISO-Code                                    *
*  - 25.10.2003 Kunden-Update hinzugefügt                                                  *
*  - 01.11.2003 Statusänderung werden wenn möglich in der Bestellsprache ausgeführt        *
*             Copyright (c) 2004 XT-Commerce                                               *
*              1.1  switching POST/GET vars for CAO imageUpload                            *
*              1.2  mulitlang inserts for Categories                                       *
*              1.3  xt:C v3.0 update                                                       *
*  - 03.12.2003 JP Bugfix beim Kunden-Export (Fehlende Felder)                             *
*               XTC  1.1 fixed bug with attributes and products qty > 1                    *
*               XTC  1.2 Updates for xt:C 3.0                                              *
*  - 10.12.2004 JP Anpassungen fuer CAO 1.2.6.x (customers_export, orders_export)          *
*  - 10.12.2004 JP Anpassungen an CAO-Faktura 1.2.6.1                                      *
*  - 01.06.2005 JP Bugfix MWST-Switch 
*  - 01.06.2005 KL/JP Anpassungen für IMAGE_MANIPULATOR (XTC 2.x und 3.x)                  *
*  - 19.08.2005 JP Bugfix beim Aktualisieren von Kunden (PW wurde neu gesetzt)             *
*  - 24.08.2005 TKI Bugfix MWST-Switch                                                     *
*               products_tax_class_id statt $products['products_tax_class_id']             *
*  - 04.10.2005 JP/KL Version 1.44 released, Scripte komplett ueberarbeitet                *
*  - 06.10.2005 KL/JP Bugfix bei xtc_set_time_limit                                        *
*  - 17.10.2005 JP Bugfixes fuer XTC 304                                                   *
*  - 21.10.2005 JP Bugfix bei Passwortuebergabe wenn das Passwort als erstes ein           *
*               numerisches Zeichen enthielt                                               *
*  - 02.11.2005 JP Fehler bei doppelter Funktion xtDBquery gefixt                          *
*  - 15.09.2006 xsell_update / erase durch Wolfgang eingebaut                              *
*               siehe : http://www.cao-faktura.de/index.php?option=com_forum&              *
*               Itemid=44&page=viewtopic&p=52192#52192                                     *    
*  - 17.11.2009 AR ProductsUpdate um Image1 und Image2 erweitert                           *
*               (Code stammt von Burn aus dem CAO Forum)                                   *
*******************************************************************************************/

//Error-Handling
$LogPHPErrors = false;

if($LogPHPErrors)
{
    error_reporting(0);
    ini_set("display_errors", "Off");
    set_error_handler("errorHandler");
}
else
    error_reporting(E_ERROR);

define('SET_TIME_LIMIT',1);   // use set_time_limit(0);

$version_nr    = '1.55.45';
$version_datum = '05.09.2017';
$last_denied_as_version = 13106;

// falls die MWST vom shop vertauscht wird, hier true setzen.
define('SWITCH_MWST',false);

define ('LOGGER',false); // Um das Loggen einzuschalten false durch true ersetzen.

// Geändert am 29.12.2010 von CM: nicht mehr benötigt, immer bis 12 Bilder akzeptieren
//define('USE_3IMAGES',true); // Für 3 Artikelbilder auf true setzen (muss von XTC unterstützt werden)
define('USE_VPE',true);

// Emails beim Kundenanlegen versenden ?
define('SEND_ACCOUNT_MAIL',false);
define('TABLE_PRODUCTS_GOOGLE_CATEGORIES', 'products_google_categories');
define('TABLE_BANKTRANSFER', 'banktransfer');
define('TABLE_PAYPAL', 'paypal');
define('TABLE_SEPA', 'sepa');
define('TABLE_GM_GPRINT_ORDERS_SURFACES_GROUPS', 'gm_gprint_orders_surfaces_groups');
define('TABLE_GM_GPRINT_ORDERS_SURFACES', 'gm_gprint_orders_surfaces');
define('TABLE_GM_GPRINT_ORDERS_ELEMENTS', 'gm_gprint_orders_elements');
define('TABLE_FEATURE_INDEX', 'feature_index');

//Tabellen für Artikel-Filter für Gambio
define('TABLE_FEATURE_DESCRIPTION', 'feature_description');
define('TABLE_FEATURE_VALUE_DESCRIPTION', 'feature_value_description');
define('TABLE_FEATURE_VALUE', 'feature_value');
define('TABLE_FEATURE','feature');

//Tabellen für Artikel-Filter bis Gambio 2.0.x.x
define('TABLE_PRODUCTS_FEATURE_VALUE', 'products_feature_value');

//Tabellen für Artikel-Filter ab Gambio 2.1.x.x
define('TABLE_FEATURE_SET', 'feature_set');
define('TABLE_FEATURE_SET_VALUES', 'feature_set_values');
define('TABLE_FEATURE_SET_TO_PRODUCTS', 'feature_set_to_products');

// Default-Sprache
// Geändert am 29.12.2010 von CM:
/*
$LangID = 2;
$Lang_folder = 'german';
*/
$DefaultLangID = 2;
$DefaultLangFolder = 'german';

// Steuer Einstellungen für CAO-Faktura

$order_total_class['ot_cod_fee']['prefix'] = '+';
$order_total_class['ot_cod_fee']['tax'] = '19';

$order_total_class['ot_customer_discount']['prefix'] = '-';
$order_total_class['ot_customer_discount']['tax'] = '19';

$order_total_class['ot_gv']['prefix'] = '-';
$order_total_class['ot_gv']['tax'] = '0';

$order_total_class['ot_loworderfee']['prefix'] = '+';
$order_total_class['ot_loworderfee']['tax'] = '19';

define ('_VALID_XTC',false);

$dependencyList = array(
    "../gm/classes/FileLog.php", 
    "../gm/inc/gm_get_conf.inc.php", //Gambio BUGFIX FileLog benötigt gm_get_config
    "../system/controls/CacheControl.inc.php", //Gambio Cache leeren
    "../gm/inc/check_data_type.inc.php", //Gambio BUGFIX CacheControl benötigt check_data_type in Gambio 2.0.13
    "../system/classes/security/PageToken.inc.php"); //Gambio BUGFIX PageToken benötigt

foreach($dependencyList as $dependency)
{
    if(file_exists($dependency))
        include_once($dependency);
}

require('../includes/application_top_export.php');

// Kundengruppen ID für Neukunden (default "neue Kunden einstellungen in XTC")
define('STANDARD_GROUP',DEFAULT_CUSTOMERS_STATUS_ID);

// Geändert am 09.06.2011 von CM: große MySql-Abfragen erlauben
xtc_db_query("SET SQL_BIG_SELECTS = 1");
xtc_db_query("SET MAX_JOIN_SIZE = 4294967295");
// Hinzugefügt am 08.10.2014 von CM: Alle Anfragen von Auction Studio sind in UTF-8
// -> Der MySQL-Server wandelt dies dynamisch in den zugrundeliegenden Zeichensatz um
// Geändert am 03.11.2014 von CM: Im gegensatzt zu SET NAMES setzte SET CHARACTER SET nicht den Zeichensatz der COLLATION
// -> Somit konvertiert MYSQL zwischen den Zeichensätzen automatisch, wenn nötig
xtc_db_query("SET CHARACTER SET 'utf8'");

//KL02062005
if (file_exists(DIR_FS_DOCUMENT_ROOT.'admin/includes/classes/image_manipulator.php'))
{
  // für XTC 2.x
  include(DIR_FS_DOCUMENT_ROOT.'admin/includes/classes/image_manipulator.php');
} else {
  // für XTC ab 3.x
  include(DIR_FS_DOCUMENT_ROOT.'admin/includes/classes/'.IMAGE_MANIPULATOR);
} //KL02062005_ENDE

if ((isset($_POST['user']))and(isset($_POST['password']))) 
{
   $user=$_POST['user'];
   $password=$_POST['password'];
} 
  else 
{
   $user=$_GET['user'];
   $password=$_GET['password'];
}

if ($user=='' or $password=='')
{
?>
<html><head><title></title></head><body>
<h3>xt:Commerce Shopanbindung</h3>
<h4>Version: <?php echo $version_nr; ?> Stand: <?php echo $version_datum; ?></h4>
<!-- <?php echo md5(__FILE__)?> -->
<br><br>
Aufruf des Scriptes mit <br><b><?php echo $PHP_SELF; ?>?user=<font color="red">ADMIN-EMAIL</font>&password=<font color="red">ADMIN-PASSWORD-IM-KLARTEXT</font>
</b>
</body></html>
<?php
  exit;
}
  else
{
    require ('xt_auctionstudio_functions.php');
      
    if(empty($_GET["as_version"]) || (intval($_GET["as_version"]) <= $last_denied_as_version && $_GET["as_version"] != "AS_Debug"))
    {
        print_xml_status(-1, $_POST['action'], 'Diese Version des Connectors ist nicht mit der verwendeten Version von Auction Studio kompatbile. Bitte aktualisieren Sie Auction Studio oder verwenden Sie einen aelteren Connector');
        exit();
    }
  
    // security  1.check if admin user with this mailadress exits, and got access to xml-export
    //           2.check if pasword = true
    if (column_exists ('admin_access','xml_export')==false)
    {
       xtc_db_query('ALTER TABLE admin_access ADD xml_export INT(1)  DEFAULT "0";');
       xtc_db_query('UPDATE admin_access SET xml_export= 1 WHERE customers_id=\'1\';');
    }

    $check_customer_query=xtc_db_query("select customers_id,
                                        customers_status,
                                        customers_password
                                        from " . TABLE_CUSTOMERS . " where
                                        customers_email_address = '" . $user . "'");

    if (!xtc_db_num_rows($check_customer_query))
    {
      SendXMLHeader ();
      print_xml_status (105, $_POST['action'], 'WRONG LOGIN', '', '', '');	 
      exit; 
    } else 
    {
        $check_customer = xtc_db_fetch_array($check_customer_query);
        // check if customer is Admin
        if ($check_customer['customers_status']!='0') 
        {
            SendXMLHeader ();
            print_xml_status (106, $_POST['action'], 'WRONG LOGIN', '', '', '');	  
            exit;
        }

        // check if Admin is allowed to access xml_export
        $access_query=xtc_db_query("SELECT
                                    xml_export
                                    from admin_access
                                    WHERE customers_id='".$check_customer['customers_id']."'");
        $access_data = xtc_db_fetch_array($access_query);
        if ($access_data['xml_export']!=1) 
        {
            SendXMLHeader ();
            print_xml_status (107, $_POST['action'], 'WRONG LOGIN', '', '', '');
            exit;
        }

        if (!( 
                /* von Byzo gehastes Passwort */
                ($check_customer['customers_password'] == $password) or 
                /* klartext Passwort */
                ($check_customer['customers_password'] == md5($password)) or
                ($check_customer['customers_password'] == md5(substr($password,2,40))) or
                (password_verify($password, $check_customer['customers_password']))
           ))
        {
            if(substr($check_customer['customers_password'],0,7) == "$2y$10$")
            {
                $pwch = substr($check_customer['customers_password'],0,29);
                $pwtype = "BCrypt";
            }
         
            SendXMLHeader ();
            print_xml_status (108, $_POST['action'], 'WRONG PASSWORD', '', '', '', '', '', $pwch, $pwtype);	  	
            
            exit;
        }
    }
}


if ($_SERVER['REQUEST_METHOD']=='GET') 
{
  switch ($_GET['action']) 
  {
     case 'version':        // Ausgabe Scriptversion
     
       SendXMLHeader ();
       SendScriptVersion ();
       exit; 
     
     case 'categories_export':
     
       SendXMLHeader ();
       SendCategories ();
       exit;
     
     case 'manufacturers_export':
     
       SendXMLHeader ();
       SendManufacturers ();
       exit;
     
     case 'orders_export':
     
       SendXMLHeader ();
       SendOrders ();
       exit;
     
     case 'products_export':
     
       SendXMLHeader ();
       SendProducts ();
       exit;
     
     case 'customers_export':
     
       SendXMLHeader ();
       SendCustomers ();
       exit;
     
     case 'customers_newsletter_export':
     
       SendXMLHeader ();
       SendCustomersNewsletter ();
       exit;
     
     case 'config_export':
     
       SendXMLHeader ();
       SendShopConfig ();
       exit;
       
     case 'send_log':
     
       SendLog ();
       exit;

     // Geändert am 19.07.2011 von CM:
     case 'products_export_count':
         SendXMLHeader();
         SendProductsCount();
         exit;
         
     // Hinzugefügt am 04.05.2012 von CM: 
     case 'categories_export_count':
         SendCategoriesCount();
         exit;
      
     // Hinzugefügt am 27.02.2013 von CM: 
     case 'clear_cache':
         SendXmlHeader();
         ClearCache();
         exit;
         
     default :     
       
       ShowHTMLMenu ();
       exit;
       
   } // End Case   
} // End Method POST
 else 
{
  if ($_SERVER['REQUEST_METHOD']=='POST') 
  {
    switch ($_POST['action']) 
    {
      case 'manufacturers_image_upload':
     
        SendXMLHeader ();
        ManufacturersImageUpload ();
        exit;
     
     case 'categories_image_upload':
     
        SendXMLHeader ();
        CategoriesImageUpload ();
        exit;
     
     case 'products_image_upload':
     
        SendXMLHeader ();
        ProductsImageUpload ();
        exit;   
        
     case 'products_image_upload_med':
     
        SendXMLHeader ();
        ProductsImageUploadMed ();
        exit;   
        
     case 'products_image_upload_large':
     
        SendXMLHeader ();
        ProductsImageUploadLarge ();
        exit;   
        
     case 'manufacturers_update':
     
        SendXMLHeader ();
        ManufacturersUpdate ();
        exit;   
        
      case 'manufacturers_erase':
     
        SendXMLHeader ();
        ManufacturersErase ();
        exit;   
        
      case 'products_update':
        
        SendXMLHeader ();
        ProductsUpdate ();
        exit;
        
      case 'products_erase':
        
        SendXMLHeader ();
        ProductsErase ();
        exit;
        
      case 'products_specialprice_update':
        
        SendXMLHeader ();
        ProductsSpecialPriceUpdate ();
        exit;
        
      case 'products_specialprice_erase':  
        
        SendXMLHeader ();
        ProductsSpecialPriceErase ();
        exit;
        
      case 'categories_update':
        
        SendXMLHeader ();
        CategoriesUpdate ();
        exit;
        
      case 'categories_erase':
        
        SendXMLHeader ();  
        CategoriesErase ();
        exit;
        
      case 'prod2cat_update':

        SendXMLHeader ();  
        Prod2CatUpdate ();
        exit;

      case 'prod2cat_erase':

        SendXMLHeader ();  
        Prod2CatErase ();
        exit;
        
      // Hinzugefügt am 27.02.2013 von CM: 
      case 'prod2cat_erase_all':
        SendXMLHeader();
        Prod2CatEraseAll();
        exit;
          
      case 'order_update':
      
        SendXMLHeader ();  
        OrderUpdate ();
        exit;
        
      case 'customers_update':
      
        SendXMLHeader ();  
        CustomersUpdate ();
        exit;
      
      case 'customers_erase':
      
        SendXMLHeader ();  
        CustomersErase ();
        exit;
        
      case 'xsell_update':
     
        SendXMLHeader ();
        XsellUpdate ();
        exit;
       
      case 'xsell_erase':
     
        SendXMLHeader ();
        XsellErase ();
        exit;  
          
    } // End Case

    // Geändert am 11.07.2011 von CM: SetOrderState Methode ist POST die action steht in GET
    if($_GET['action'] == "order_states_upload")
    {
        SetOrderStates();
        exit;
    }

  }  // End Method POST
}

function errorHandler ($errno, $errmsg, $filename, $linenum, $vars) { 
    $time=date("d M Y H:i:s"); 

    $errortype = array (1     => "Error",
                        2     => "Warning",
                        4     => "Parsing Error",
                        8     => "Notice",
                        16    => "Core Error",
                        32    => "Core Warning",
                        64    => "Compile Error",
                        128   => "Compile Warning",
                        256   => "User Error",
                        512   => "User Warning",
                        1024  => "User Notice",
                        2048  => "Strict",
                        4096  => "Recoverable Error",
                        8192  => "Deprecated",
                        16384 => "User Depricated"); 

    $errlevel=$errortype[$errno]; 

    //Write error to log file (CSV format) 
    $errfile=fopen("errors.csv","a"); 
    if($errfile === false)
        die("Die Datei errors.csv konnte nicht geöffnet werden. Bitte prüfen Sie die Dateiberechtigungen des Ordners");

    fputs($errfile,"\"$time\",\"$filename: $linenum\",\"($errlevel) $errmsg\"\r\n"); 
    fclose($errfile); 

    if(strpos($errlevel, "Error") !== false) {
        //Terminate script if fatal errror
        die("Ein fataler Fehler ist aufgetreten. Das Ausführen des Scriptes wurde abgebrochen. Bitte kontaktieren Sie den Support von Auction Studio und senden Sie die as_error.csv mit."); 
    } 
}

?>